!
! Define if you want to use SCA
!USESCA = 1

EXE = [.exe]
.IFDEF DEBUG
OBJ = [.dbg]
.ELSE
OBJ = [.obj]
.ENDIF
SRC = []
.IFDEF USESCA
SCALIBRARY = [.scalib]
.ENDIF
!
!	The system we're building
!
system : makedir $(EXE)cswing.exe $(EXE)most.exe
    dir/date/siz $(EXE)cswing.exe;,$(EXE)most.exe

makedir :
.IFDEF DEBUG
   @ if f$search("dbg.dir") .eqs. "" then create/dir <.dbg>
.ENDIF
   @ if f$search("obj.dir") .eqs. "" then create/dir <.obj>
   @ if f$search("exe.dir") .eqs. "" then create/dir <.exe>

clean :
.IFDEF DEBUG
   @ delete [.dbg]*.obj;*,*.ana;*
.ELSE
   @ delete [.obj]*.obj;*,*.ana;*
.ENDIF
   @ delete [.exe]*.exe;*  

!
!	Macros
!
OBJECTS = $(OBJ)swing.obj, $(OBJ)swing_1.obj, -
        $(OBJ)swing_2.obj,  $(OBJ)swing_3.obj,  $(OBJ)swing_4.obj, -
	$(OBJ)swing_5.obj,  $(OBJ)swing_6.obj,  $(OBJ)swing_7.obj,  -
        $(OBJ)swing_8.obj,  $(OBJ)swing_9.obj,  $(OBJ)swing_10.obj, -
	$(OBJ)swing_11.obj, $(OBJ)swing_12.obj, $(OBJ)swing_13.obj, -
        $(OBJ)swing_14.obj, $(OBJ)swing_15.obj, $(OBJ)swing_16.obj, -
        $(OBJ)swing_17.obj, $(OBJ)swing_18.obj, $(OBJ)swing_19.obj, -
        $(OBJ)swing_20.obj, $(OBJ)swing_21.obj, $(OBJ)swing_22.obj, -
        $(OBJ)swing_23.obj, $(OBJ)swing_24.obj, $(OBJ)swing_25.obj, -
        $(OBJ)swing_26.obj, $(OBJ)swing_27.obj, $(OBJ)swing_28.obj, -
        $(OBJ)swing_29.obj, $(OBJ)swing_30.obj, $(OBJ)swing_31.obj, -
        $(OBJ)swing_32.obj, $(OBJ)swing_33.obj, $(OBJ)swing_34.obj, -
	$(OBJ)swing_35.obj, $(OBJ)swing_36.obj, $(OBJ)swing_37.obj, -
        $(OBJ)swing_38.obj, $(OBJ)swing_39.obj, $(OBJ)most.obj, -
	$(OBJ)buffer.obj, $(OBJ)cmd.obj, $(OBJ)dir.obj, $(OBJ)display.obj, -
	$(OBJ)edit.obj, $(OBJ)file.obj, $(OBJ)help.obj, $(OBJ)keym.obj, -
	$(OBJ)line.obj, $(OBJ)main.obj, $(OBJ)search.obj, $(OBJ)sysdep.obj, -
	$(OBJ)window.obj
!
.IFDEF USE_DECC
!
CFLAGS =             /stand=vaxc/nodebug/nolist/opt/object=$(OBJ)
!
OPTFILE =             options_file.decc
MOSTOPT =             most_options.decc
!
.ELSE
!
.IFDEF DEBUG
.IFDEF USESCA
CFLAGS =             /debug/ana=$(OBJ)/nolist/noopt/object=$(OBJ)
.ELSE
CFLAGS =             /debug/nolist/noopt/object=$(OBJ)
.ENDIF
.ELSE
.IFDEF USESCA
CFLAGS =             /nodebug/ana=$(OBJ)/nolist/opt/object=$(OBJ)
.ELSE
CFLAGS =             /nodebug/nolist/opt/object=$(OBJ)
.ENDIF
.ENDIF
!
OPTFILE =             options_file.vaxc
MOSTOPT =             most_options.vaxc
!
.ENDIF
!
.IFDEF DEBUG
LFLAGS =	     /nouserlib/debug/traceback/nomap
.ELSE
LFLAGS =	     /nouserlib/nodebug/traceback/nomap
.ENDIF
!
.C.OBJ :
        $(CC) $(CFLAGS) $(MMS$SOURCE)
.IFDEF USESCA
        mms$scalib = F$TRNLNM( "SCA$LIBRARY" )
        mms$scasetlib = 0
        IF mms$scalib .EQS. "" .AND. "$(SCALIBRARY)" .NES. "SCA$LIBRARY:" -
                THEN mms$scasetlib = 2
        IF mms$scalib .NES. "" .AND. "$(SCALIBRARY)" .NES. "SCA$LIBRARY:" -
                .AND. mms$scalib .NES. "$(SCALIBRARY)" THEN mms$scasetlib = 3
        IF F$SEARCH("$(SCALIBRARY)SCA$EVENT.DAT") .EQS. "" THEN -
                mms$scasetlib = (mms$scasetlib .AND. .NOT. 2) .OR. 4
        IF ((mms$scasetlib .AND. 4) .EQ. 4) THEN -
                $(SCA) CREATE LIBRARY $(SCAFLAGS) $(SCALIBRARY)
        IF ((mms$scasetlib .AND. 4) .EQ. 4) .OR. ((mms$scasetlib .AND. 2) -
                .EQ. 2) THEN DEFINE/USER SCA$LIBRARY $(SCALIBRARY)
        $SCA LOAD $(SCAFLAGS) $(MMS$TARGET_NAME).ANA
.ENDIF

$(EXE)cswing.exe : $(OBJ)swing.olb
    link/exe=$(EXE)cswing.exe $(OBJ)swing.olb/lib/inc=swing, - 
        $(SRC)$(OPTFILE)/opt $(LFLAGS)
    @ purge /nolog/noconf/keep=1 $(EXE)cswing.exe
!
$(EXE)most.exe : $(OBJ)swing.olb $(OBJ)main.most
    link/exe=$(EXE)most.exe $(OBJ)main.most,$(OBJ)swing.olb/lib, -
        $(SRC)$(MOSTOPT)/opt $(LFLAGS)
    @ purge /nolog/noconf/keep=1 $(EXE)most.exe

$(OBJ)swing.olb : $(OBJECTS)
    @ purge /nolog/noconf/keep=1 $(OBJ)*.obj
    library /create $(OBJ)swing.olb $(OBJ)*.obj 
    @ purge /nolog/noconf/keep=1 $(OBJ)swing.olb

$(OBJ)swing.obj : swing.c, swing.h, swing_defs.h
!
$(OBJ)swing_1.obj : swing_1.c, swing.h, swing_refs.h
$(OBJ)swing_2.obj : swing_2.c, swing.h, swing_refs.h
$(OBJ)swing_3.obj : swing_3.c, swing.h, swing_refs.h
$(OBJ)swing_4.obj : swing_4.c, swing.h, swing_refs.h
$(OBJ)swing_5.obj : swing_5.c, swing.h, swing_refs.h
$(OBJ)swing_6.obj : swing_6.c, swing.h, swing_refs.h
$(OBJ)swing_7.obj : swing_7.c, swing.h, swing_refs.h
$(OBJ)swing_8.obj : swing_8.c, swing.h, swing_refs.h
$(OBJ)swing_9.obj : swing_9.c, swing.h, swing_refs.h
$(OBJ)swing_10.obj : swing_10.c, swing.h, swing_refs.h
$(OBJ)swing_11.obj : swing_11.c, swing.h, swing_refs.h
$(OBJ)swing_12.obj : swing_12.c, swing.h, swing_refs.h
$(OBJ)swing_13.obj : swing_13.c, swing.h, swing_refs.h
$(OBJ)swing_14.obj : swing_14.c, swing.h, swing_refs.h
$(OBJ)swing_15.obj : swing_15.c, swing.h, swing_refs.h
$(OBJ)swing_16.obj : swing_16.c, swing.h, swing_refs.h
$(OBJ)swing_17.obj : swing_17.c, swing.h, swing_refs.h
$(OBJ)swing_18.obj : swing_18.c, swing.h, swing_refs.h
$(OBJ)swing_19.obj : swing_19.c, swing.h, swing_refs.h
$(OBJ)swing_20.obj : swing_20.c, swing.h, swing_refs.h
$(OBJ)swing_21.obj : swing_21.c, swing.h, swing_refs.h
$(OBJ)swing_22.obj : swing_22.c, swing.h, swing_refs.h
$(OBJ)swing_23.obj : swing_23.c, swing.h, swing_refs.h
$(OBJ)swing_24.obj : swing_24.c, swing.h, swing_refs.h
$(OBJ)swing_25.obj : swing_25.c, swing.h, swing_refs.h
$(OBJ)swing_26.obj : swing_26.c, swing.h, swing_refs.h
$(OBJ)swing_27.obj : swing_27.c, swing.h, swing_refs.h
$(OBJ)swing_28.obj : swing_28.c, swing.h, swing_refs.h, fatdef.h, fm2def.h
$(OBJ)swing_29.obj : swing_29.c, swing.h, swing_refs.h, printmenu.h
$(OBJ)swing_30.obj : swing_30.c, swing.h, swing_refs.h
$(OBJ)swing_31.obj : swing_31.c, swing.h, swing_refs.h, fatdef.h, fh2def.h, fm2def.h
$(OBJ)swing_32.obj : swing_32.c, swing.h, swing_refs.h
$(OBJ)swing_33.obj : swing_33.c, swing.h, swing_refs.h
$(OBJ)swing_34.obj : swing_34.c, swing.h, swing_refs.h
$(OBJ)swing_35.obj : swing_35.c, swing.h, swing_refs.h
$(OBJ)swing_36.obj : swing_36.c, swing.h, swing_refs.h
$(OBJ)swing_37.obj : swing_37.c, swing.h, swing_refs.h
$(OBJ)swing_38.obj : swing_38.c, swing.h, swing_refs.h
$(OBJ)swing_39.obj : swing_39.c, swing.h, swing_refs.h
$(OBJ)localfix.obj : localfix.c, swing.h, swing_refs.h
$(OBJ)most.obj : most.c, most.h, externs.h, window.h, buffer.h, file.h, sysdep.h, keym.h, search.h
$(OBJ)buffer.obj : buffer.c , buffer.h, externs.h, display.h, line.h
$(OBJ)cmd.obj : cmd.c, sysdep.h, search.h, window.h, file.h, keym.h, externs.h
$(OBJ)dir.obj : dir.c, buffer.h, window.h, file.h
$(OBJ)display.obj : display.c, buffer.h, display.h, sysdep.h
$(OBJ)edit.obj : edit.c, externs.h, window.h, sysdep.h
$(OBJ)file.obj : file.c, externs.h, file.h, keym.h, buffer.h, window.h, sysdep.h
$(OBJ)help.obj : help.c, window.h, file.h, display.h, line.h, externs.h, sysdep.h
$(OBJ)keym.obj : keym.c, externs.h, keym.h, sysdep.h, display.h, buffer.h, window.h, search.h
$(OBJ)line.obj : line.c, buffer.h, externs.h, display.h, line.h
$(OBJ)main.obj : main.c, externs.h, window.h, buffer.h, file.h, sysdep.h, most.h, display.h
!
.IFDEF USE_DECC
!
$(OBJ)main.most : main.c, externs.h, window.h, buffer.h, file.h, sysdep.h, most.h, display.h
    cc main/stand=vaxc/nodebug/nolist/opt/define=(STANDALONE)/object=$(OBJ)main.most
!
.ELSE
!
$(OBJ)main.most : main.c, externs.h, window.h, buffer.h, file.h, sysdep.h, most.h, display.h
    cc main/nodebug/nolist/opt/define=(STANDALONE)/object=$(OBJ)main.most
!
.ENDIF
!
$(OBJ)search.obj : search.c, most.h, externs.h, buffer.h, line.h
$(OBJ)sysdep.obj : sysdep.c, sysdep.h, externs.h, display.h
$(OBJ)window.obj : window.c, externs.h, window.h, line.h, display.h, sysdep.h
