/**************************************************************
**
**         C SWING  v 3.1   31-JUL-1989 09:08:54.30
**         =========================================
**
**         Author    :  S.J.Brown
**
**         Copyright :  Public Domain
**
**         File      :  SWING_26.C
**
**         Language  :  VAXC
**
**         Compiler  :  VAX/VMS C v 2.4
**
**         VMS Ver.  :  5.1
**
***************************************************************
**
**         Change History
**         ==============
**
**         Date        Change                          Initials
**         ----------------------------------------------------
**         31-JUL-1989 Initial Version v3.0               SJB
**
**************************************************************/
 
/*
**  swing_26 - user options
*/
#include <stdio.h>
#include <ssdef.h>
#include <smgdef.h>
#include "more_descrip.h"
#include "swing.h"
#include "swing_refs.h"

/*
**  allow user to change his / her options
*/
user_options(option,filename,n,file_type)
NODE *n;
int option;
char *filename;
int file_type;
{
    /*
    **  let the user change his options
    **
    **  arg option - TRUE ==> displayf is current display, we're in the
    **  file manager
    */
    FILER *original_ffp, *original_cfp;
    int status, i;
    int original_cursor_line, original_total_files, original_curr_file_no;
    int original_curr_top_file;

    original_ffp = first_file_ptr;
    original_cfp = curr_file_ptr;
    original_cursor_line = cursor_line;
    original_total_files = total_files;
    original_curr_file_no = curr_file_no;
    original_curr_top_file = curr_top_file;

    cursor_line = -1;
    curr_file_ptr = 0;
    total_files = 0;
    curr_file_no = 0;
    curr_top_file = 0;

    please_wait();
    build_list_of_options();

    title(UTITLE);

    /*
    **  centre sub-title
    */
    for (i = 0; i < 40; i++)
        junk[i] = ' ';
    
    sprintf(&junk[40 - (strlen(USER_OPTIONS_FILE))/2],"%s",USER_OPTIONS_FILE);
    /*
    **  and display it
    */
    sub_title_normal(junk);

    status = smg$erase_display(&displayf);
    if (status != SS$_NORMAL)
        panic(status,"erase display","user options");

    status = smg$label_border(&displayf,DSC1(" USER-DEFINABLE OPTIONS "),
                         &SMG$K_TOP,0,&(SMG$M_REVERSE));
    if (status != SS$_NORMAL)
        panic(status,"label border displayf","user options");

    if (option == FALSE)
    {
        status = smg$paste_virtual_display(&displayf,&paste,&DISPLAYF_Y,&DISPLAYF_X);
        if (status != SS$_NORMAL)
            panic(status,"paste","user options");
    }
    show_files(TRUE,USER_OPTIONS);

    message("");

    /*
    **  allow user to change his options
    */
    next_user_option(filename);

    /*
    **  free up any memory we may have used
    */
    free_files(first_file_ptr);

    if (option == FALSE)
    {
        status = smg$unpaste_virtual_display(&displayf,&paste);
        if (status != SS$_NORMAL)
            panic(status,"unpaste","user options");
    }
    else
    {
        status = smg$erase_display(&displayf);
        if (status != SS$_NORMAL)
            panic(status,"erase display","user options");

        file_manager_label(file_type,n);
    }

    first_file_ptr = original_ffp;
    curr_file_ptr = original_cfp;
    cursor_line = original_cursor_line;
    total_files = original_total_files;
    curr_file_no = original_curr_file_no;
    curr_top_file = original_curr_top_file;
}

/*
**  get next command from the user
*/
next_user_option(filename)
char *filename;
{
    int key, changed;

    changed = FALSE;

    while(1)
    {
        key = get_key(ALLOW_AUTO | ALLOW_CLOCK);

        if (key == SMG$K_TRM_QUESTION_MARK)
            key = define_menu_options();

        if (!key)
            continue;

        switch(key)
        {
case SMG$K_TRM_UPPERCASE_O:
case SMG$K_TRM_LOWERCASE_O:
            show_broadcasts();
            break;

case SMG$K_TRM_HELP:
case SMG$K_TRM_UPPERCASE_H:
case SMG$K_TRM_LOWERCASE_H:
            swing_help("SWING COMMANDS FILE");
            break;

case SMG$K_TRM_DOLLAR_SIGN:
            execute_dcl("");
            break;
            
case SMG$K_TRM_CTRLJ:
case SMG$K_TRM_UP:
            if (curr_file_no)
            {
                curr_file_no--;
                if (curr_file_no < curr_top_file)
                {
                    curr_top_file -= (3 * DISPLAYF_ROWS)/4;
                    show_files(TRUE,USER_OPTIONS);
                }
                else
                    show_files(FALSE,USER_OPTIONS);
            }          
            break;

case SMG$K_TRM_CTRLK:
case SMG$K_TRM_DOWN:
            if (curr_file_no < (total_files - 1))
            {
                curr_file_no++;
                if (curr_file_no >= (curr_top_file + DISPLAYF_ROWS))
                {
                    curr_top_file += (3 * DISPLAYF_ROWS)/4;
                    show_files(TRUE,USER_OPTIONS);
             
                }
                else
                    show_files(FALSE,USER_OPTIONS);
            }
            break;

case SMG$K_TRM_UPPERCASE_N :
case SMG$K_TRM_LOWERCASE_N :
case SMG$K_TRM_NEXT_SCREEN :
            if (curr_file_no < (total_files - 1))
            {
                curr_file_no += FILE_PAGE_ROWS;
                curr_top_file = curr_file_no - FILE_PAGE_ROWS;
                show_files(TRUE,USER_OPTIONS);
            }
            break;

case SMG$K_TRM_UPPERCASE_B :
case SMG$K_TRM_LOWERCASE_B :
            if (curr_file_no < (total_files - 1))
            {
                curr_file_no = total_files - 1;
                show_files(FALSE,USER_OPTIONS);
            }
            break;

case SMG$K_TRM_PREV_SCREEN :
case SMG$K_TRM_UPPERCASE_P :
case SMG$K_TRM_LOWERCASE_P :
            if (curr_file_no)
            {
                curr_file_no -= FILE_PAGE_ROWS;
                curr_top_file = curr_file_no - 
                                (DISPLAYF_ROWS - FILE_PAGE_ROWS - 1);
                show_files(TRUE,USER_OPTIONS);
            }
            break;

case SMG$K_TRM_UPPERCASE_T :
case SMG$K_TRM_LOWERCASE_T :
            if (curr_file_no)
            {
                curr_file_no = 0;
                show_files(FALSE,USER_OPTIONS);
            }
            break;

case SMG$K_TRM_LOWERCASE_Q:
case SMG$K_TRM_UPPERCASE_Q:
            if (changed) 
            {
                if (confirm_user("Really QUIT and lose any changes Y/N [N] ?","Y"))
                    return(TRUE);
                else
                    break;
            }
            else
                return(TRUE);
            break;

case SMG$K_TRM_LOWERCASE_E:
case SMG$K_TRM_UPPERCASE_E:
            if (changed)
                save_definitions();
            return(TRUE);
            break;

case SMG$K_TRM_LOWERCASE_C:
case SMG$K_TRM_UPPERCASE_C:
case SMG$K_TRM_SPACE:
            changed = TRUE;
            change_option(current_file_ptr(curr_file_no),curr_file_no);
            break;

case SMG$K_TRM_LOWERCASE_R:
case SMG$K_TRM_UPPERCASE_R:
            default_value(current_file_ptr(curr_file_no),curr_file_no);
            break;

default:
            if (!function_key(key,filename))
                ding(displayb);
            break;
        }
    }
}

/*
**  build up the list of options
*/
build_list_of_options()
{
    FILER *f;
    int i;
    char line[SCREEN_WIDTH+1];

    for (i = 0; options_list[i].key; i++)
    {
        make_option_line(line,i);
        f = grab_file(line);
        f->info_lookup = options_list[i].key;
        f->size = strlen(options_list[i].value);
    }
}

/*
**  build up a line for display on the user's terminal
*/
make_option_line(line,i)
char *line;
int i;
{
    int len;
    int nt;
    int file;
    char tmp[SCREEN_WIDTH+20];

    /*
    **  build up in tmp, then copy to line, making sure we don't have too 
    **  much information to display
    */
    len = strlen(options_list[i].value);
    nt = file = 0;

    sprintf(tmp,
            "%s%s",
            options_list[i].key_name,
            options_list[i].value);
    
    if (options_list[i].key < 0)
    {
        strcpy(line,tmp);
	goto fn_exit;
    }

    /*
    **  if no terminate set flag
    */
    if (options_list[i].no_terminate)
    {
	nt = TRUE;
    }

    /*
    **  if the last char was not ! set flag
    */
    if (len && !ends_in_excl(options_list[i].value))
    {
	file = TRUE;
    }

    if (file)
	strcat(tmp," <file>");

    if (nt)
	strcat(tmp," <nt>");

fn_exit:;
    /*
    **  string could be too long, so we'll take care
    */
    if (strlen(tmp) > SCREEN_WIDTH)
	tmp[SCREEN_WIDTH] = 0;

    strcpy(line,tmp);
}

/*
**  allow user to change an option - prompt for new value with old value
**  as the prompt string
*/
change_option(f,l)
FILER *f;
int l;
{
    int len;
    char ip[SCREEN_WIDTH+1];

    /*
    **  highlight current option
    */
    f->rendition = CHOSEN_FILE_RENDITION;
    show_files(TRUE,USER_OPTIONS);

    /*
    **  use tempory string
    */
    strcpy(ip,options_list[l].value);

    /*
    **  add no terminate char as appropriate
    */
    if (options_list[l].key > 0 &&
        options_list[l].no_terminate)
        sprintf(&ip[strlen(ip)],"%c",NO_TERMINATE_CHAR);

    /*
    **  now if the length of what we have to display is as big as what we 
    **  are going to allow the user to enter, we'll truncate the input to
    **  SCREEN_WIDTH -1 chars long;
    */
    len = strlen(options_list[l].key_name);
    if (len + strlen(ip) >= SCREEN_WIDTH)
    {
        ip[SCREEN_WIDTH-1-len] = 0;
    }

    get_user_input_with_prompt(options_list[l].key_name,
                               ip,
                               SCREEN_WIDTH);

    strcpy(options_list[l].value,ip);

    /*
    **  if there is a list of valid input we'll check against it
    */
    switch(l)
    {
case OL_FM_TYPE:
        if (options_list[l].value[0] < '0' || 
            options_list[l].value[0] > '9')
	{
	    warning("File format must be in the range 0 to 9");
            strcpy(options_list[l].value, options_list[l].original);
            f->rendition = 0;
            show_files(TRUE,USER_OPTIONS);
	    return(FALSE);
	}
	break;
default:
	break;
    }

    /*
    **  check if user supplied a no terminate character
    */
    check_no_terminate(l);

    /*
    **  rebuild display line
    */
    make_option_line(f->filename,l);
    f->size = strlen(options_list[l].value);

    /*
    **  update display, sleep one second, unhighlight display
    */
    show_files(TRUE,USER_OPTIONS);
    sleep(1);
    f->rendition = 0;
    show_files(TRUE,USER_OPTIONS);
}

/*
**  restore the default value for element l of the user list
*/
default_value(f,l)
FILER *f;
int l;
{
    strcpy(options_list[l].value, options_list[l].original);
    f->rendition = CHOSEN_FILE_RENDITION;
    show_files(TRUE,USER_OPTIONS);
    strcpy(options_list[l].value,options_list[l].original);
    make_option_line(f->filename,l);
    f->size = strlen(options_list[l].value);
    show_files(TRUE,USER_OPTIONS);
    sleep(1);
    f->rendition = 0;
    show_files(TRUE,USER_OPTIONS);
}

/*
**  save the current definitions in a disk file
*/
save_definitions()
{
    FILE *fp;
    int i;
    char filename[SPEC_SIZE+1];

    sprintf(filename,"SWING$SAVE:%s",USER_OPTIONS_FILE);

    if (access(filename,0) == 0)
        delete_a_file(filename);

    fp = fopen(filename,"w","alq=3","mbc=3");
    if (fp == NULL)
    {
        sprintf(filename,"sys$login:%s",USER_OPTIONS_FILE);

        if (access(filename,0) == 0)
            delete_a_file(filename);

        fp = fopen(filename,"w","alq=3","mbc=3");
        if (fp == NULL)
        {
            sprintf(junk,"cannot create file %s",filename);    
            warning(junk);
            return(FALSE);
        }
    }
    message("Saving definitions ...");
    fprintf(fp,"!\n");
    fprintf(fp,"!   SWING definitions file - this file contains the\n");
    fprintf(fp,"!   user definable options used by\n");
    fprintf(fp,"!   %s\n",VERSION);
    fprintf(fp,"!     , a directory manager tool.\n");
    fprintf(fp,"!\n");
    fprintf(fp,"!   User %s\n",this_user);
    fprintf(fp,"!\n");
    fprintf(fp,"!   The file should NOT be deleted\n");
    fprintf(fp,"!\n");

    for (i = 0; options_list[i].key; i++)
    {
        fprintf(fp,"!\n");    
        fprintf(fp,"!  %s\n",options_list[i].key_name);
        if (options_list[i].key > 0 &&
            options_list[i].no_terminate)
            fprintf(fp,"%s%c\n",options_list[i].value,NO_TERMINATE_CHAR);
        else
            fprintf(fp,"%s\n",options_list[i].value);
        strcpy(options_list[i].original,options_list[i].value);
    }

    fclose(fp);

    message("Saved definitions ...");

    build_names();

    return(TRUE);
}

/*
**  load user's options from a disk file
*/
load_definitions(option)
int option;
{
    FILE *fp;
    int i, l, len;
    char line[SCREEN_WIDTH+1];
    char filename[SPEC_SIZE+1];

    sprintf(filename,"SWING$SAVE:%s",USER_OPTIONS_FILE);
    fp = fopen(filename,"r","mbc=3");
    if (fp == NULL)
    {
        sprintf(filename,"sys$login:%s",USER_OPTIONS_FILE);
        fp = fopen(filename,"r","mbc=3");
        if (fp == NULL)
        {
            if (option == TRUE)
            {
                warning("Creating user definitions file ...");
                if (!save_definitions())
                     return(FALSE);
                else
                    return(load_definitions(FALSE));
            }
        }
    }
   
    message("Loading definitions ...");

    l = 0;

    while(1)
    {
        line[0] = 0;

        if (options_list[l].key == 0 ||
            fgets(line,SCREEN_WIDTH,fp) == NULL)
        {
            fclose(fp);
            break;
        }

        if (line[0] == '!')
            continue;

        for (i = 0; i < strlen(line); i++)
            if (line[i] == '\n')
            {
                line[i] = 0;
                break;
            }

         
        strcpy(options_list[l].value,    line);
        check_no_terminate(l);
        strcpy(options_list[l].original, line);
        l++;
    }

    build_names();
}

/*
**  build up dynamically held names
*/
build_names()
{
    char val;

    /*
    **  extract the print queue, batch queue and editor from the
    **  options list - we handle these separately
    */
    if (options_list[OL_PRINT_QUEUE].value[0])
        strcpy(print_queue,options_list[OL_PRINT_QUEUE].value);
    else
    {
        strcpy(options_list[OL_PRINT_QUEUE].value,
               options_list[OL_PRINT_QUEUE].default_value);
        strcpy(print_queue,options_list[OL_PRINT_QUEUE].default_value);
    }
   
    if (options_list[OL_BATCH_QUEUE].value[0])
        strcpy(batch_queue,options_list[OL_BATCH_QUEUE].value);
    else
    {
        strcpy(options_list[OL_BATCH_QUEUE].value,
               options_list[OL_BATCH_QUEUE].default_value);
        strcpy(batch_queue,options_list[OL_BATCH_QUEUE].default_value);
    }
        
    strcpy(editor_defn,options_list[OL_EDITOR_DEFN].value);

    val = options_list[OL_FM_TYPE].value[0];
    if (val && val >= '0' && val <= '9')
        fm_type = (int)(val - '0');
}

/*
**  check if user terminated the string with NO_TERMINATE_CHAR - 
**  if he did, we'll remove the char and set the no_terminate element
**  of the structure, otherwise we'll clear this element
**      note
**  we can't do this for the print queues and batch queues etc
*/
check_no_terminate(l)
int l;
{
    int len,i;

    /*
    **  check we're changing a definable key
    */
    if (options_list[l].key < 0)
	return(TRUE);
    
    len = strlen(options_list[l].value) - 1;
    options_list[l].no_terminate = FALSE;

    for (i = len; i >= 0; i--)
    {
        if (options_list[l].value[i] == NO_TERMINATE_CHAR)
        {
    	    options_list[l].no_terminate = TRUE;
            options_list[l].value[i] = 0;
	    return(TRUE);
        }
        else if (options_list[l].value[i] != ' ')
        {
	    return(FALSE);
        }
    }
}
